=== debian/changelog ===
putty (0.81-2) unstable; urgency=medium

  * Migrate to debputy to avoid needing fakeroot.

 -- Colin Watson <cjwatson@debian.org>  Wed, 05 Jun 2024 16:18:12 +0100

putty (0.81-1) unstable; urgency=high

  * Build-depend on pkgconf rather than pkg-config.
  * New upstream release:
    - CVE-2024-31497: Fix exposure of NIST P521 ECDSA private keys by biased
      signature generation.

 -- Colin Watson <cjwatson@debian.org>  Mon, 15 Apr 2024 23:41:28 +0100

putty (0.80-1) unstable; urgency=high

  * New upstream release:
    - CVE-2023-48795: Mitigations for SSH protocol 'Terrapin' vulnerability.

 -- Colin Watson <cjwatson@debian.org>  Mon, 18 Dec 2023 17:42:06 +0000

putty (0.79-1) unstable; urgency=medium

  * debian/upstream/signing-key.asc: Drop 2018 release key; add 2023 release
    key
    (https://www.chiark.greenend.org.uk/~sgtatham/putty/keys/release-2023.asc).
  * New upstream release:
    - GTK: fix crash changing font size when terminal maximised (closes:
      #1038788).

 -- Colin Watson <cjwatson@debian.org>  Sun, 27 Aug 2023 22:36:26 +0100

putty (0.78-3) unstable; urgency=medium

  * Clean icons/*.svg (closes: #1047016).

 -- Colin Watson <cjwatson@debian.org>  Mon, 14 Aug 2023 13:48:06 +0100
