## putty 0.82

=== debian/changelog ===
putty (0.82-2~mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Thu, 09 Jan 2025 21:47:11 +0000

putty (0.82-2) unstable; urgency=medium

  * Fix undefined behaviour with small keypad (closes: #1087844).

 -- Colin Watson <cjwatson@debian.org>  Tue, 10 Dec 2024 11:55:44 +0000

putty (0.82-1) unstable; urgency=medium

  * New upstream release:
    - Fix segfault and test failures if certain hardware crypto acceleration
      is unavailable (closes: #1087798).

 -- Colin Watson <cjwatson@debian.org>  Thu, 28 Nov 2024 01:08:32 +0000

putty (0.81-3) unstable; urgency=medium

  [ Bastien Roucariès ]
  * Run test/cryptsuite.py during build.

  [ Colin Watson ]
  * Apply X-Style: black.
  * Remove execute_after_dh_auto_test-arch conditional, unnecessary with
    debhelper 13 (thanks, Niels Thykier).

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Oct 2024 18:29:53 +0100
