=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.gpg/ \
https://the.earth.li/~sgtatham/putty/latest/putty-(.*)\.tar\.gz
